Attribute VB_Name = "Module1"
' Direct3D Sample 4 / Exemple Direct3D7 4 : Explosion
' Cet exemple est dj mieux mais il s'amliorera.
' This example isn't very wonderful but it will be more later...
'
' 23/12 Now use the Alpha blending !!
'       Utilise maintenant l'alpha blending
'
' 27/12 Now use mouse move
'       Maintenant utilise la souris
'
Public DirectX As DirectX7
Public DD As DirectDraw7
Public D3D As Direct3D7
Public EnumDevice As Direct3DEnumDevices
Public EnumDD As DirectDrawEnum
Public Primary As DirectDrawSurface7
Public BackBuffer As DirectDrawSurface7
Public D3DSurface As DirectDrawSurface7
Public Device As Direct3DDevice7
Public Viewport As D3DVIEWPORT7
Public ZBuffer As DirectDrawSurface7

Public DeviceReturn As Long
Public DriverGUID As String
Public AppStop As Boolean
Public Triangle1(2) As D3DVERTEX
Public Triangle2(2) As D3DVERTEX
Public Expl(6) As D3DVERTEX
Public mem As Integer
Public Texture(50) As DirectDrawSurface7
Public Mat(50) As D3DMATERIAL7
Public Light2(50) As D3DLIGHT7

' Pour lire des fichers TrueEditor v.7
Public w As Enregistrement7

Public gauche, droite, haut, bas, boum As Integer, explframe As Integer, espace, att, xpos As Single, ypos As Single, zpos As Single, systemframe As Single
Public descend, monte, LookY
Public Enum TEXTUREFLAGS
 D3DTEXTR_DEFAULT = 0
 D3DTEXTR_TRANSPARENTblack = 1
 D3DTEXTR_TRANSPARENTWHITE = 2
End Enum
Public Type TextureType
 Width As Integer
 Height As Integer
 filename As String
End Type

Public Type Faces
  NumVertex As Integer
  TextureIndex As Integer
  MaterialIndex As Integer
  TypeFace As Integer
  SectAttr As Integer
  LigneAttr As Integer
  Vertexes() As D3DVERTEX
End Type
Public Type LightType
 TypeLight As Long
 Position As D3DVECTOR
 Orientation As D3DVECTOR
 color As D3DCOLORVALUE
 Attenuation0 As Single
 Attenuation1 As Single
 Attenuation2 As Single
 Range As Single
 Falloff As Single
End Type
Public Type LigneType2
 BY1 As Integer
 BY2 As Integer
 CollideType As Boolean
 Texture As Integer
 Texture1 As Integer
 Texture2 As Integer
 color As Long
End Type

'------------------------------------
' Enregistrement TV 7.0
'------------------------------------
 Public Type Mat7
   ambient As D3DCOLORVALUE
   emissive As D3DCOLORVALUE
   specular As D3DCOLORVALUE
   diffuse As D3DCOLORVALUE
   power As Single
   NumTexture As Integer
 End Type
 
 Public Type Enregistrement7
   VersionEnregistrement As Integer
   NumTexture As Integer
   Textures() As TextureType
   NumFace As Integer
   Face() As Faces
   Materials() As Mat7
   Lights() As LightType
 End Type
 
Function Teste(d1, d2, d3)
 eu = (-(d2 ^ 2) + d3 ^ 2 + d1 ^ 2) / (2 * d3)
 If eu < d3 And d2 - eu < d3 Then
  Y20 = Abs(d1 ^ 2 - (((d1 ^ 2 - d2 ^ 2 + d3 ^ 2) / (d3 * 2))) ^ 2)
  y = Sqr(Y20)
  If y < 15 Then Teste = 2
  If y < 3 Then Teste = 1
  
 End If
End Function




Public Function CreateTextureSurface(sFile As String, extraFlags As TEXTUREFLAGS, w As Long, h As Long) As DirectDrawSurface7
    Dim bOK As Boolean
    Dim enumTex As Direct3DEnumPixelFormats
    Dim sLoadFile As String
    Dim i As Long
    Dim ddsd3 As DDSURFACEDESC2
    Dim SurfaceObject As DirectDrawSurface7
    Dim Init As Boolean
    On Error GoTo 789
    ddsd3.lFlags = DDSD_CAPS Or DDSD_TEXTURESTAGE Or DDSD_PIXELFORMAT
    If ((h <> 0) And (w <> 0)) Then
        ddsd3.lFlags = ddsd3.lFlags Or DDSD_HEIGHT Or DDSD_WIDTH
        ddsd3.lHeight = h
        ddsd3.lWidth = w
    End If
    
     
    Set enumTex = Device.GetTextureFormatsEnum()
    
   
    For i = 1 To enumTex.GetCount()
        bOK = True
        Call enumTex.GetItem(i, ddsd3.ddpfPixelFormat)
            
        With ddsd3.ddpfPixelFormat
            
            If .lRGBBitCount <> 16 Then bOK = False
            If .lFourCC <> 0 Then bOK = False
                        
            
            If ((D3DTEXTR_TRANSPARENTblack And extraFlags) _
                  Or (D3DTEXTR_TRANSPARENTWHITE And extraFlags)) Then
                  If (.lRGBAlphaBitMask = 0) Then bOK = False
                  'DDPF_ALPHAPIXELS
            Else
                  If (.lRGBAlphaBitMask <> 0) Then bOK = False
            End If
                  
            
        End With
        If bOK = True Then Exit For
    Next
    
    If bOK = False Then
        Debug.Print "Unable to find 16bit surface support on your hardware - exiting"
        Init = False
    End If
    Debug.Print "Requis"
    If (((D3DTEXTR_TRANSPARENTblack And extraFlags) _
          Or (D3DTEXTR_TRANSPARENTWHITE And extraFlags))) Then
        ddsd3.ddpfPixelFormat.lFlags = DDPF_ALPHAPIXELS Or DDPF_RGB
        ddsd3.lFlags = ddsd.lFlags Or DDSD_PIXELFORMAT
        
    Else
        ddsd3.ddpfPixelFormat.lFlags = DDPF_RGB
  
    End If
    
    ' voodoo 2 change
    If Device.GetDeviceGuid() <> "IID_IDirect3DRGBDevice" Then
            ddsd3.ddscaps.lCaps = DDSCAPS_TEXTURE
            ddsd3.ddscaps.lCaps2 = DDSCAPS2_TEXTUREMANAGE
            ddsd3.lTextureStage = 0
 Debug.Print "Ohoh"
    Else
            ddsd3.ddscaps.lCaps = DDSCAPS_TEXTURE Or DDSCAPS_SYSTEMMEMORY
            ddsd3.ddscaps.lCaps2 = 0
            ddsd3.lTextureStage = 0

 
    End If

    If sFile = "" Then
        Set SurfaceObject = DD.CreateSurface(ddsd3)
    Else
        Set SurfaceObject = DD.CreateSurfaceFromFile(sFile, ddsd3)
    End If
    
    
 
    
    If Not (((D3DTEXTR_TRANSPARENTblack = extraFlags) _
        Or (D3DTEXTR_TRANSPARENTWHITE = extraFlags)) _
        ) Then Set CreateTextureSurface = SurfaceObject: Exit Function

        
        
    Dim ddsd4 As DDSURFACEDESC2
    Dim mem() As Integer
    Dim lAlphaMask As Long
    Dim lRGBMask As Long
    Dim lColorKey As Long
    Dim c As Long
    Dim x As Long
    Dim y As Long
    Dim r1 As RECT
    
    ReDim mem(ddsd.lHeight * ddsd.lPitch)
    Dim vf As DDCOLORKEY
    vf.high = RGB(0, 0, 0)
    vf.low = RGB(0, 0, 0)
   SurfaceObject.SetColorKey DDCKEY_DESTBL, vf
    With ddsd3.ddpfPixelFormat
        lAlphaMask = .lRGBAlphaBitMask
        lRGBMask = .lRBitMask Or .lGBitMask Or .lBBitMask
    End With
    If (extraFlags And D3DTEXTR_TRANSPARENTWHITE) Then
        lColorKey = lRGBMask     'color key on white
    End If
    If (extraFlags And D3DTEXTR_TRANSPARENTblack) Then
        lColorKey = 0                  'color key on black
    End If
    
    'pixel format should be 16 bit because thats what we selected
    Dim rl As RECT
    
    r1.Bottom = ddsd3.lHeight
    r1.Right = ddsd3.lWidth
    SurfaceObject.Lock r1, ddsd3, DDLOCK_WAIT, 0
    
    ' Add an opaque alpha value to each non-colorkeyed pixel
    For y = 0 To ddsd3.lHeight - 1
        For x = 0 To ddsd3.lWidth - 1
            c = SurfaceObject.GetLockedPixel(x, y)
            If c And lRGBMask <> lColorKey Then
                SurfaceObject.SetLockedPixel x, y, c Or lAlphaMask
            End If
        Next
    Next

    SurfaceObject.Unlock r1
         Set CreateTextureSurface = SurfaceObject
        Exit Function
789:
 Debug.Print "Error Create surface "; Err.Description + " "; Err.Number
 Resume Next
End Function



Function DDRect(x, y, x1, y1) As RECT
With DDRect
  .Left = x
  .Right = x1
  .Top = y
  .Bottom = y1
  End With
End Function

Public Sub SetViewFrustrum(nearZ As Single, farZ As Single, radian As Single)
    Dim x As Single
    Dim y As Single
            
    Dim matProj As D3DMATRIX
    Dim ddsd As DDSURFACEDESC2
     BackBuffer.GetSurfaceDesc ddsd
    
    x = ddsd.lHeight / ddsd.lWidth
    radian = radian / 2
    
    matProj.rc11 = Cos(radian) / Sin(radian)
    radian = radian * x
    matProj.rc22 = Cos(radian) / Sin(radian)
    matProj.rc33 = farZ / (farZ - nearZ)
    matProj.rc43 = -matProj.rc33 * nearZ
    matProj.rc34 = 1
    If Device Is Nothing Then Exit Sub
    Device.SetTransform D3DTRANSFORMSTATE_PROJECTION, matProj
    
End Sub


Sub AppError(Text As String)
 Unload3D
 AppStop = True
 MsgBox Text + Chr(13) + Chr(13) + Err.Description + Chr(13) + Chr(10) + "Contactez Sylvain Dupont sur sylvain.dupont@francimel.com" + Chr(13) + "Contact Sylvain Dupont at sylvain.dupont@francimel.com", vbCritical, "Erreur / Error"
 End
 
End Sub

'---------------------
' Direct3D 7 Sample 2
'---------------------
Function AttatchZBuffer() As Boolean
    On Local Error GoTo errOut
            
    
    Dim hr As Integer
    Dim ddsZBuff  As DirectDrawSurface7
    Dim ddsd As DDSURFACEDESC2
    Dim ddsdZ As DDSURFACEDESC2
    
    Dim l As Long
    Dim i As Long

 
    Dim fenum As Direct3DEnumPixelFormats
    Set fenum = D3D.GetEnumZBufferFormats(DriverGUID)
    l = fenum.GetCount()
    
    If l = 0 Then
       
        Debug.Print "Aucun ZBuffer"
        AttatchZBuffer = True
       Exit Function
    End If
    
    For i = 1 To l
        Call fenum.GetItem(i, ddsdZ.ddpfPixelFormat)
    
    Debug.Print "Z buffer"; ddsdZ.ddpfPixelFormat.lZBufferBitDepth
    If ddsdZ.ddpfPixelFormat.lZBufferBitDepth = 16 Then Exit For
    
    Next
    

                           
    ddsdZ.lFlags = DDSD_CAPS Or DDSD_WIDTH Or DDSD_HEIGHT Or DDSD_PIXELFORMAT
    ddsdZ.ddscaps.lCaps = DDSCAPS_ZBUFFER Or mem
    ddsdZ.lWidth = 640
    ddsdZ.lHeight = 480
    
    Set ZBuffer = DD.CreateSurface(ddsdZ)
    
    BackBuffer.AddAttachedSurface ZBuffer
    
    AttatchZBuffer = True
    Exit Function
errOut:
    Debug.Print Err.Description + " PRob"
    AttatchZBuffer = False
End Function

Public Function DXColor(r As Single, g As Single, b As Single, a As Single) As D3DCOLORVALUE
 With DXColor
  .a = a
  .b = b
  .g = g
  .r = r
 End With
 
End Function

Sub Main()
 On Error GoTo errs

 If Command = "COLLIDE" Then Form2.Show: Exit Sub
 '
 ' Procdure d'initialisation
 ' Init procedure
 Set DirectX = New DirectX7

 
 Set DD = DirectX.DirectDrawCreate("")
 Set D3D = DD.GetDirect3D
 
 
 ' Et voici la dtection de matriel !!
 ' And this is the hardware detection !
 Set EnumDD = DirectX.GetDDEnum
 Set EnumDevice = D3D.GetDevicesEnum
 
 ' Demande  l'utilisateur quel driver il veut(si plus de 2)
 ' Ask user the driver to use.
 If EnumDevice.GetCount > 1 Then
  DriverSelect.List1.Clear
  For i = 1 To EnumDevice.GetCount
   DriverSelect.List1.AddItem EnumDevice.GetDescription(i)
  Next i
DriverSelect.Show 1
  If DeviceReturn = -1 Then Unload3D: End
  DriverGUID = EnumDevice.GetGuid(DeviceReturn)
 End If
 If DeviceReturn = 1 Then mem = DDSCAPS_SYSTEMMEMORY Else mem = DDSCAPS_VIDEOMEMORY
 'On ferme tout et on recommence
' Close all.
 Set DD = Nothing
 
 Form1.Show
 
 Set DD = DirectX.DirectDrawCreate(EnumDD.GetGuid(1))
 Set D3D = DD.GetDirect3D
 DD.SetCooperativeLevel Form1.hWnd, DDSCL_FULLSCREEN Or DDSCL_EXCLUSIVE Or DDSCL_ALLOWREBOOT
 DD.SetDisplayMode 640, 480, 16, 0, DDSDM_DEFAULT
 
 
 ' Cre la surface primaire / Create the primary surface
 Dim ddsd2 As DDSURFACEDESC2
 ddsd2.lFlags = DDSD_BACKBUFFERCOUNT Or DDSD_CAPS
 ddsd2.ddscaps.lCaps = DDSCAPS_COMPLEX Or DDSCAPS_FLIP Or DDSCAPS_PRIMARYSURFACE Or mem Or DDSCAPS_3DDEVICE
 ddsd2.lBackBufferCount = 1
 Set Primary = DD.CreateSurface(ddsd2)
 
 'Cre le BackBuffer / Create the backbuffer
 Dim ddscaps As DDSCAPS2
 ddscaps.lCaps = DDSCAPS_BACKBUFFER
 Set BackBuffer = Primary.GetAttachedSurface(ddscaps)
 
BackBuffer.BltColorFill DDRect(0, 0, 640, 480), 0

 
If AttatchZBuffer() = False Then AppError "Le Z Buffer n'a pas pas pu tre cr. / The Z-Buffer haven't been created"
Set Device = D3D.CreateDevice(DriverGUID, BackBuffer)
 
 
 ' Dfinit le viewport / Set the viewport
 Viewport.lX = 0
 Viewport.lY = 0
 Viewport.lHeight = 480
 Viewport.lWidth = 640
 Viewport.minz = 0#
 Viewport.maxz = 1#
 Device.SetViewport Viewport
 InitDS
 boum = LoadWave(App.Path + "\bomb.wav")
 
 SetDefaults
  DrawScene
 AppLoop
errs:
 Debug.Print "Desc :"; Err.Description; "  "; Err.Number
 Unload3D
 End
End Sub
Private Sub DrawScene()
 ' Procedure for reading TrueVisionEditor map.
On Error GoTo 55
 Dim filen As String

 Open App.Path + "\explo2.bsp" For Binary As 1
  Get #1, , w
 Close
If Command = "COLLIDE" Then Exit Sub
  Dim i As Integer
 ' Cre tous les objets matriels et lumires
 Debug.Print "mat"
 
 For i = 1 To UBound(w.Materials)
   Debug.Print "mat"; i
   Mat(i) = Material(w.Materials(i).ambient, w.Materials(i).diffuse, w.Materials(i).emissive, w.Materials(i).specular, w.Materials(i).power, 0)
 Next i
  Debug.Print "tex"; w.NumTexture
  For i = 1 To w.NumTexture
     
     For h = Len(w.Textures(i).filename) To 1 Step -1
       If Mid(w.Textures(i).filename, h, 1) = "\" Then Exit For
     Next h
     filen = Mid$(w.Textures(i).filename, h + 1)
     Debug.Print App.Path + "\" + filen
    Set Texture(i) = CreateTextureSurface(App.Path + "\" + filen, D3DTEXTR_DEFAULT, 0, 0)
  Next i
  Debug.Print "light"
  For i = 1 To UBound(w.Lights)
   Light2(i).Range = w.Lights(i).Range
   Light2(i).dltType = D3DLIGHT_POINT
   Light2(i).ambient = w.Lights(i).color
   Light2(i).diffuse = w.Lights(i).color
   Light2(i).specular = w.Lights(i).color
   Light2(i).direction = w.Lights(i).Orientation
   Light2(i).Position = w.Lights(i).Position
   Light2(i).Attenuation0 = 1
   Light2(i).Attenuation1 = 0
   Light2(i).Attenuation2 = 0
   
   Device.SetLight i, Light2(i)
   Device.LightEnable i, True
  Next i
Exit Sub
55:
Debug.Print Err.Description + " Draw Scene"
Unload3D
End
End Sub

Function RECT(x, y, x1, y1) As D3DRECT
 With RECT
  .x1 = x
  .X2 = x1
  .y1 = y
  .Y2 = y1
  End With
End Function

'  '* => nouveau code pour l'explosion
'     => new code for the explosion
'
Public Sub AppLoop()
On Error GoTo 0
Dim matrix As D3DMATRIX
Dim mat2 As D3DMATRIX
Dim identity As D3DMATRIX
Dim viewm As D3DMATRIX
Dim mat3 As D3DMATRIX
 On Error GoTo ert
 DirectX.IdentityMatrix matrix
 
Device.SetRenderTarget BackBuffer
Device.SetRenderState D3DRENDERSTATE_LIGHTING, 1
Device.SetRenderState D3DRENDERSTATE_ZENABLE, 1

xpos = 40
zpos = 30

ypos = -15
'
' Load explosion sprites.
' Charge les images de l'explosion
Dim kk As DDCOLORKEY
kk.high = RGB(0, 0, 0)
kk.low = RGB(0, 0, 0)

For i = 1 To 15
 Set Texture(i + 10) = CreateTextureSurface(App.Path + "\12" + Format(i, "000") + ".bmp", 0, 0, 0)
 ' Applique la couleur-cl noire / Apply the keycolor for this texture.
 Texture(i + 10).SetColorKey DDCKEY_SRCBLT, kk                         '*
Next i
Set Texture(9) = CreateTextureSurface(App.Path + "\glow04.bmp", 0, 0, 0)
Texture(9).SetColorKey DDCKEY_SRCBLT, kk

Dim ClearTab(1) As D3DRECT
 ClearTab(0) = RECT(0, 0, 640, 480)
 Device.GetTransform D3DTRANSFORMSTATE_VIEW, viewm

' Linear texture filtering
' Filtre de textures linaire
'
Device.SetTextureStageState 0, D3DTSS_MAGFILTER, 2
Device.SetTextureStageState 0, D3DTSS_MINFILTER, 2
 
 Expl(1) = Vertex(-10, -10, 0, 0, 0, -1, 0, 0)            '*
 Expl(2) = Vertex(10, -10, 0, 0, 0, -1, 1, 0)            '*
 Expl(3) = Vertex(-10, 10, 0, 0, 0, -1, 0, 1)           '*
       
 Expl(4) = Vertex(-10, 10, 0, 0, 0, -1, 0, 1)            '*
 Expl(5) = Vertex(10, -10, 0, 0, 0, -1, 1, 0)            '*
 Expl(6) = Vertex(10, 10, 0, 0, 0, -1, 1, 1)             '*
 
 Device.SetRenderState D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE
 Device.SetRenderState D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE
 
 Do
   ' Nttoie toutes les surfaces
   ' Clean all the surfaces
   
   Device.Clear 1, ClearTab, D3DCLEAR_TARGET Or D3DCLEAR_ZBUFFER, 0, 1, 0
   
  '----------------------------------------------
  ' Affiche les triangles sur l'cran
  ' Display the textured triangles on the screen
  '----------------------------------------------
Device.ComputeSphereVisibility Vector(xpos, ypos, zpos), 0.1
   DirectX.IdentityMatrix mat3
   mat3 = MRotate(mat3, 0, ang - 90, 0)
   mat3 = MTranslate(mat3, 70, 42, 47)
   Device.BeginScene
 ' Place la matrice de transformation du monde  (0,0,0) angle 0
 ' Put the transform matrix at 0,0,0 angle 0
 Device.SetTransform D3DTRANSFORMSTATE_WORLD, matrix
 For i = 1 To w.NumFace
 If w.Materials(w.Face(i).MaterialIndex).NumTexture <> anc1 Then
    anc1 = w.Materials(w.Face(i).MaterialIndex).NumTexture
    Device.SetMaterial Mat(w.Face(i).MaterialIndex)
    Device.SetTexture 0, Texture(w.Materials(w.Face(i).MaterialIndex).NumTexture)
End If
' Pendant l'explosion, matrial clair '*
If explframe > 0 And explframe < 5 Then anc1 = -5: Device.SetMaterial Material(DXColor(5, 5, 5, 1), DXColor(5, 5, 5, 1), DXColor(5, 5, 5, 1), DXColor(5, 5, 5, 1), 1, 0)
' After explosion, unable the explosion lights. '*
If explframe = 5 Then Device.LightEnable 7, False '*
 
' Draw the triangles
' Dessine les triangles.
 Device.DrawPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, w.Face(i).Vertexes(1), 6, 0
 
 Next i
 
 '
 ' Draw the glow (Z-Buffer stop)
 '
 Device.SetRenderState D3DRENDERSTATE_ZFUNC, D3DCMP_ALWAYS
 
 
 Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, True
 Device.SetTransform D3DTRANSFORMSTATE_WORLD, mat3
 Device.SetMaterial Material(DXColor(1, 1, 1, 1), DXColor(1, 0, 0, 1), DXColor(1, 0, 0, 1), DXColor(1, 1, 1, 1), 1, 0)
 Device.SetTexture 0, Texture(9)
 Device.DrawPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Expl(1), 6, 0 '*

 
 Device.SetRenderState D3DRENDERSTATE_ZFUNC, D3DCMP_LESSEQUAL
 
 If explframe > 0 And explframe < 16 Then '*
 Device.SetTransform D3DTRANSFORMSTATE_WORLD, mat2 '*
 Device.SetMaterial Material(DXColor(1, 1, 1, 0.3), DXColor(1, 1, 1, 0.3), DXColor(1, 1, 1, 0.3), DXColor(1, 1, 1, 0.3), 1, 0) '*
 Device.SetTexture 0, Texture(10 + explframe) '*
 Device.SetRenderState D3DRENDERSTATE_COLORKEYENABLE, True '*
 Device.DrawPrimitive D3DPT_TRIANGLELIST, D3DFVF_VERTEX, Expl(1), 6, 0 '*
   
   End If
    Device.SetRenderState D3DRENDERSTATE_ALPHABLENDENABLE, False
   If explframe = 16 Then explframe = 0
   Device.EndScene
  '
  ' It's all ! The 3D-drawing is on the surface !
  '
    BackBuffer.SetFontTransparency True
   BackBuffer.SetForeColor RGB(256, 128, 0)
   BackBuffer.DrawText 180, 400, CStr(xpos) + " " + CStr(ypos) + " " + CStr(zpos) + " " + CStr(ang), False

  'Compute and display the frame rate
  im = im + 1
  systemframe = DirectX.TickCount - frametime
  frametime = DirectX.TickCount
  If DirectX.TickCount > anc + 1000 Then
  imsec = Int((im / ((DirectX.TickCount - anc) / 1000)) * 100) / 100
  im = 0
  anc = DirectX.TickCount
  BackBuffer.DrawText 560, 15, CStr(systemframe), False
  End If
  BackBuffer.DrawText 560, 0, CStr(imsec) + " imsec", False


   Primary.Flip Nothing, DDFLIP_WAIT
   If Err.Number = DDERR_SURFACELOST Then Primary.restore
   DoEvents
 
 ' Gestions des touches appuyes
 ' Events for key press.

xpos1 = xpos: ypos1 = ypos: zpos1 = zpos
 
 If gauche = True Then ang = ang - 0.09 * systemframe
 If droite = True Then ang = ang + 0.09 * systemframe
 If descend = True Then LookY = LookY + 0.05 * systemframe
 If monte = True Then LookY = LookY - 0.05 * systemframe
 
 If haut = True Then xpos = xpos + Cos(ang * PIFactor) * systemframe * 0.3: zpos = zpos + Sin(ang * PIFactor) * 0.3 * systemframe
 If bas = True Then xpos = xpos - Cos(ang * PIFactor) * systemframe * 0.3: zpos = zpos - Sin(ang * PIFactor) * 0.3 * systemframe
 
 att = 0
 u = 0

 '
 ' Detection de collision / collision detecting
 '
 If explframe > 0 And explframe < 5 Then '*
 xpos = xpos - 8 / explframe              '*
 End If
   testexpl = 0
   For Av = 1 To w.NumFace '
  d1 = Sqr((w.Face(Av).Vertexes(1).x - xpos) ^ 2 + (w.Face(Av).Vertexes(1).z - zpos) ^ 2)
  d2 = Sqr((w.Face(Av).Vertexes(3).x - xpos) ^ 2 + (w.Face(Av).Vertexes(3).z - zpos) ^ 2)
  d3 = Sqr((w.Face(Av).Vertexes(1).x - w.Face(Av).Vertexes(3).x) ^ 2 + (w.Face(Av).Vertexes(1).z - w.Face(Av).Vertexes(3).z) ^ 2)
  att = 0
  y1 = w.Face(Av).Vertexes(1).y
  Y2 = w.Face(Av).Vertexes(4).y
  
 ' If Y2 = y1 Then y1 = w.Face(Av).Vertexes(2).y: Y2 = w.Face(Av).Vertexes(1).y
  'If ypos - 10 < y1 And ypos + 10 > Y2 Then
    
  If d1 + d2 < d3 ^ 2 And w.Face(Av).TypeFace = 1 Then
   att = Teste(d1, d2, d3)
   If att = 1 Then u = 1
  End If
  'End If
  
   If Av = 7 And att = 2 Then testexpl = 1
  Next Av
 If u = 1 Then
  xpos = xpos1: ypos = ypos1: zpos = zpos1
 End If
If explframe > 0 Then

 If DirectX.TickCount > ancp + 100 Then '*
  ancp = DirectX.TickCount              '*
 If explframe < 15 Then                '*

 End If                                 '*
 explframe = explframe + 1              '*
 End If
End If

 If espace = True And explframe = 0 And testexpl = 1 Then '*
   explframe = 1                                        '*
 DirectX.IdentityMatrix mat2
 mat2 = MScale(mat2, 3, 3, 3)                            '*
 
 mat2 = MRotate(mat2, 0, ang - 90, 0) '*
 mat2 = MTranslate(mat2, 160, 30, 50)
 
 Dim lig As D3DLIGHT7                                     '*
 lig.ambient = DXColor(10, 10, 10, 1)                      '*
 lig.diffuse = DXColor(10, 10, 10, 1)                       '*
 lig.dltType = D3DLIGHT_POINT                               '*
 lig.Range = 15000                                            '*
 lig.Attenuation0 = 1                                       '*
 lig.specular = DXColor(10, 10, 10, 1)                       '*
 Device.SetLight 7, lig                                    '*
 Device.LightEnable 7, True                                 '*                               '*
  DSStop boum
  DSB(boum).SetCurrentPosition 0
   DSPlay boum                                               '*
 End If                                                      '*
' SetListenerPosition xpos, ypos, zpos
 viewm = MLookAt(Vector(xpos, ypos, zpos), Vector(xpos + Cos(ang * PIFactor) * 100, ypos + LookY, zpos + Sin(ang * PIFactor) * 100))
   Device.SetTransform D3DTRANSFORMSTATE_VIEW, viewm
  
  
  Loop Until AppStop = True
 
 End
ert:
Debug.Print Err.Description
Resume Next
 
End Sub






Public Sub SetDefaults()
  Dim matWorld As D3DMATRIX, matView As D3DMATRIX
    Dim Mat As D3DMATERIAL7
    Dim Light As D3DLIGHT7
    
    DirectX.IdentityMatrix matWorld
    DirectX.IdentityMatrix matView
    Call DirectX.ViewMatrix(matView, Vector(0, 0, -20), Vector(0, 0, 0), Vector(0, 1, 0), 0)
    
    Device.SetTransform D3DTRANSFORMSTATE_WORLD, matWorld
    Device.SetTransform D3DTRANSFORMSTATE_VIEW, matView
    SetViewFrustrum 1, 1000, 3.1416 / 4
     
    With Light
        .dltType = D3DLIGHT_POINT
 
        .ambient = DXColor(1, 1, 0.5, 0.5)
        .diffuse = DXColor(1, 1, 0.5, 0.5)
        .specular = DXColor(1, 1, 0.5, 0.5)
        .Position.y = 10
    End With
        
    Device.SetLight 0, Light
    Device.LightEnable 0, True
    
    Mat.ambient = DXColor(4, 4, 4, 0)
    Mat.diffuse = DXColor(0.5, 0.5, 0.5, 1)
    Mat.specular = DXColor(0.5, 0.5, 0.5, 0)
    Mat.emissive = DXColor(0.5, 0.5, 0.5, 0)
    
    ' Set the material as the current material
  Device.SetMaterial Mat
    
    
End Sub
Public Function Material(ambient As D3DCOLORVALUE, diffuse As D3DCOLORVALUE, emissive As D3DCOLORVALUE, specular As D3DCOLORVALUE, power As Single, TexHandle As Integer) As D3DMATERIAL7
 With Material
  .ambient = ambient
  .diffuse = diffuse
  .emissive = emissive
  .power = power
  .specular = specular
 End With
End Function
Sub Touche()

End Sub

Sub Unload3D()
 '------------------------------------------------------------
 ' Je crois que l'on n'est mme plus oblig de passer par l !
 '------------------------------------------------------------
 
 '* I think these code is inutile
AppStop = True
On Error Resume Next
 DD.RestoreDisplayMode
 DD.SetCooperativeLevel Form1.hWnd, DDSCL_NORMAL
 Set Primary = Nothing
 Set BackBuffer = Nothing
 Set Device = Nothing
 Set DD = Nothing
 Set D3D = Nothing
 Set DirectX = Nothing

End Sub


Public Function Vertex(x As Single, y As Single, z As Single, nx As Single, ny As Single, nz As Single, tv As Single, tu As Single) As D3DVERTEX
With Vertex
 .nx = nx
 .ny = ny
 .nz = nz
 .tu = tu
 .tv = tv
 .x = x
 .y = y
 .z = z
End With
End Function

Function Vector(x As Single, y As Single, z As Single) As D3DVECTOR
 With Vector
  .x = x
  .y = y
  .z = z
 End With
End Function

